input HTRANS[1:0], HREADY, HSEL;
output HRESP[1:0];

define a_idle   = !HTRANS[0] & !HTRANS[1];
define a_busy   =  HTRANS[0] & !HTRANS[1];
define a_nonseq = !HTRANS[0] &  HTRANS[1];
define a_seq    =  HTRANS[0] &  HTRANS[1];

define a_okay  = !HRESP[0] & !HRESP[1];
define a_error =  HRESP[0] & !HRESP[1];
define a_retry = !HRESP[0] &  HRESP[1];
define a_split =  HRESP[0] &  HRESP[1];

slave -> (idle || transfer)*;

idle -> (!HSEL) || (HSEL & !HREADY);

transfer -> idle_transfer   ||
            busy_transfer   ||
            nonseq_transfer ||
            seq_transfer;

idle_transfer -> (a_idle & HSEL & HREADY) @ okay_response;

busy_transfer -> (a_busy & HSEL & HREADY) @ okay_response;

nonseq_transfer -> (a_nonseq & HSEL & HREADY) @ response; 

seq_transfer -> (a_seq & HSEL & HREADY) @ response; 

response -> 
    wait_state* ,
    (okay_response || error_response || split_response || retry_response);

wait_state -> !HREADY & a_okay;

okay_response  ->  HREADY & a_okay;
error_response -> (!HREADY & a_error) , (HREADY & a_error);
retry_response -> (!HREADY & a_retry) , (HREADY & a_retry);
split_response -> (!HREADY & a_split) , (HREADY & a_split);

