/*
 * The Pipelined Regular Expression Monitor Compiler System
 * Copyright (c) 2002 University of British Columbia
 * All Rights Reserved.
 *
 *
 * Translates the DAG (parse tree) to circuit. 
 *
 * Marcio Oliveira -- 2002
 */

#ifndef TRANSLATION_H
#define TRANSLATION_H

#include <dd.h>
#include <compile.h>

typedef struct wire *wirePtr;
struct wire {
    int index;
    treeNodePtr f;
    wirePtr next;
};

typedef struct controlPoint *controlPointPtr;
struct controlPoint {
    int index;
    treeNodePtr f;
    controlPointPtr next;
};

typedef struct actionPoint *actionPointPtr;
struct actionPoint {
    int index;
    actionPtr actionList;
    treeNodePtr f;
    actionPointPtr next;
};

typedef struct exThread *exThreadPtr;
struct exThread {
    int index;
    treeNodePtr ok;
    treeNodePtr active;
    treeNodePtr enable;
    treeNodePtr rec;
    exThreadPtr next; 
};

treeNodePtr build(treeNodePtr, treeNodePtr, treeNodePtr, 
                  treeNodePtr *, treeNodePtr *, treeNodePtr *,
                  treeNodePtr *, treeNodePtr *, treeNodePtr *); 
controlPointPtr createControlPoint();
void createActionPoint(actionPtr, treeNodePtr);
void createExThread(treeNodePtr, treeNodePtr, treeNodePtr, treeNodePtr);
treeNodePtr copyAndSubstitute(treeNodePtr, treeNodePtr, treeNodePtr);
int lambda(treeNodePtr); 
treeNodePtr createWireNode(treeNodePtr);

#endif 
